#!/bin/bash
set -x
#DISK="physical_device" 
DISK="/dev/sdb" 

#cleanup
umount /mnt/tmp2
for ((j = 0; j < 2; j++)) ; do
    echo -n "Remove $j "
    date
    umount /mnt/m$j
    lvremove -f /dev/VG/sn_$j
done
vgchange -a n VG
vgremove -f VG
rm /var/log/lvm2.log
sudo dmesg -c > /dev/null
echo -e "Initialization\n" > kernel_logs

# initialization
pvcreate  $DISK 2> /dev/null
vgcreate VG $DISK 2> /dev/null
vgchange -a y VG
lvcreate -L20G -n lv VG
mkdir -p /mnt/tmp2
mkfs.xfs /dev/VG/lv
mount /dev/VG/lv /mnt/tmp2
sudo dmesg -c >> kernel_logs

#snapshot #1
echo -e "\n\nLV 0" >> kernel_logs

echo -e "\nlv0 create" >> kernel_logs
lvcreate -L512M -n /dev/VG/sn_0 VG
mkdir -p /mnt/m0
sudo dmesg -c >> kernel_logs

echo -n "Convert 0 "; date

echo -e "\nlv0 convert" >> kernel_logs
lvconvert -s -c512 /dev/VG/lv /dev/VG/sn_0
echo "lvconvert exited with code: $?"
sudo dmesg -c >> kernel_logs

echo -e "\nlv0 mount" >> kernel_logs
mount -t xfs -o nouuid,noatime /dev/VG/sn_0 /mnt/m0
echo "mount exited with code: $?"
sudo dmesg -c >> kernel_logs

echo -e "\nlv0 sync on empty lv" >> kernel_logs
sync
echo "sync on empty lv exited with code: $?"
sudo dmesg -c >> kernel_logs

dd bs=1M count=550 if=/dev/zero of=/mnt/tmp2/tmp
echo -e "\nlv0 sync" >> kernel_logs
sync
echo "sync exited with code: $?"
sudo dmesg -c >> kernel_logs

#snapshot #2
echo -e "\n\nLV 1" >> kernel_logs

echo -e "\nlv1 create" >> kernel_logs
lvcreate -L512M -n /dev/VG/sn_1 VG
mkdir -p /mnt/m1
sudo dmesg -c >> kernel_logs

echo -n "Convert 1 "; date

echo -e "\nlv1 convert" >> kernel_logs
lvconvert -s -c512 /dev/VG/lv /dev/VG/sn_1
echo "lvconvert exited with code: $?"
sudo dmesg -c >> kernel_logs

echo -e "\nlv1 mount" >> kernel_logs
mount -t xfs -o nouuid,noatime /dev/VG/sn_1 /mnt/m1
echo "mount exited with code: $?"
sudo dmesg -c >> kernel_logs

echo -e "\nlv1 sync" >> kernel_logs
sync #hang up
echo "sync exited with code: $?"
sudo dmesg -c >> kernel_logs #have to do manually due to hang up
